def _pgcd(a, b):
    """Renvoie le pgcd de a et de b."""
    while b != 0: # Le PGCD de a et 0 est a
        a, b = b, a%b # Le PGCD de a est de b est aussi celui de b et de a%b
    return a

def fraction(n, d):
    """Renvoie une fraction irreductible correspondant
    à n/d et dont le dénominateur est positif."""
    assert d != 0 # Le dénomnateur ne peut pas être nul
    ...
    return ...

def numerateur(f):
    """Renvoie le numérateur de la fraction f."""
    return ...

def denominateur(f):
    """Renvoie le dénominateur de la fraction f."""
    return ...

def decimal(f):
    """Renvoie la valeur décimale, approchée si nécessaire, de la fraction f."""
    return ...

def est_entier(f):
    """Renvoie un booléen indiquant si f
    est égale à un nombre entier ou pas."""
    return ...

def inverse(f):
    """Renvoie une fraction irreductible égale à
    l'inverse de f et dont le dénominateur est positif."""
    n = numerateur(f)
    d = denominateur(f)
    return ...

def oppose(f):
    """Renvoie une fraction irreductible égale à
    -f et dont le dénominateur est positif."""
    ...
    return ...

def somme(f1, f2):
    """Renvoie une fraction irreductible égale à
    f1 + f2 et dont le dénominateur est positif."""
    n1 = numerateur(f1)
    d1 = denominateur(f1)
    n2 = numerateur(f2)
    d2 = denominateur(f2)
    return ...

def produit(f1, f2):
    """Renvoie une fraction irreductible égale à
    f1 * f2 et dont le dénominateur est positif."""
    ...
    return ...

def division(f1, f2):
    """Renvoie une fraction irreductible égale à
    f1 : f2 et dont le dénominateur est positif."""
    return ...

def egalite(f1, f2):
    """Renvoie un booléen équivalent à f1 == f2."""
    ...
    return ...

def inferieur(f1, f2):
    """Renvoie un booléen équivalent à f1 < f2."""
    ...
    return ...

def puissance(f, k):
    ...
    return ...

def texte(f):
    """Renvoie un texte de la forme 'n/d'
    ou 'n' si le dénominateur vaut 1."""
    ...
    return ...

